package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLAccessInfo_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLAccessInfo extends JNIObject  {
	
	/* @generated */
	protected ISLAccessInfo(long ptr) {
		/*** PROTECTED REGION ID(ISLAccessInfo_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLAccessInfo build(long ptr) {
		return new ISLAccessInfo(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLAccessInfo_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_access_info_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_access_info_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_access_info_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_access_info_compute_flow 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLFlow computeFlow() {
		/*** PROTECTED REGION ID(isl_access_info_compute_flow) DISABLED START ***/
		ISLFlow res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLFlow.build(ISLNative.isl_access_info_compute_flow(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLAccessInfo_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
